/*
  f-cpu/c/registers/registers_view.c
  shows status of regsiter unit for f-cpu simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com

Sun Jul 21 02:47:46 CEST 2002 JWS: added flags to view
Sun Jul 21 10:05:05 CEST 2002 JWS: display register numbers in decimal

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#include <stdio.h>
#include <fcpusim.h>

void registers_view(void){
  int reg_view_cnt;

  printf("registers: (1..63)  ");
  for (reg_view_cnt=1;reg_view_cnt<64;reg_view_cnt++){
    printf("%2i=",reg_view_cnt);
    g(); printf("%16llX", register_value[reg_view_cnt]); n();
    if ((reg_view_cnt % 4)==3) { printf("\n"); }else { printf(" "); }
  }
  printf(  "reg_nr_R0="); g(); printf("%2i" ,reg_nr_R0); n();
  printf("  reg_R0="); g(); printf("%16llX" ,reg_R0); n();
  printf( " reg_w0_reg_nr="); g(); printf("%2i" ,reg_w0_reg_nr); n();
  printf("  reg_W0="); g(); printf("%16llX" ,reg_W0); n();
  printf("\nreg_nr_R1="); g(); printf("%2i" ,reg_nr_R1); n();
  printf("  reg_R1="); g(); printf("%16llX" ,reg_R1); n();
  printf( " reg_w1_reg_nr="); g(); printf("%2i" ,reg_w1_reg_nr); n();
  printf("  reg_W1="); g(); printf("%16llX", reg_W1); n();
  printf("\nreg_nr_R2="); g(); printf("%2i" ,reg_nr_R2); n();
  printf("  reg_R2="); g(); printf("%16llX", reg_R2); n();

  printf("\nreg_ZERO = "); print_true_false(reg_ZERO);
  printf( " reg_MSB = ");  print_true_false(reg_MSB);
  printf( " reg_LSB = ");  print_true_false(reg_LSB);
  printf( " reg_FP = ");   print_true_false(reg_FP);
  printf( " reg_align ="); g(); printf("%2X" ,reg_align); n();

  printf("\n");

}
