/* 
  f-cpu/c/scheduler/fetcher_view.c
  shows status of fetcher unit
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version: 19 July 2002 13:30
Sun Jul 21 10:06:39 CEST 2002 JWS: display opcode numbers in decimal
Mon Jul 22 23:02:02 CEST 2002 JWS: finisched major scheduling update

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#include <stdio.h>
#include <fcpusim.h>

void fetcher_view(void){
  printf("fetcher input:\n");
  printf(  "fet_ip         = "); g(); printf("%16llX",fet_ip); n();
  /* add code memory interface */
  printf("\n");

  printf("fetcher output:\n");
  printf(  "fet_cip        = "); g(); printf("%16llX",fet_cip); n();
  printf("\nfet_nip        = "); g(); printf("%16llX",fet_nip); n();
  printf("\nfet_instr      = "); g(); printf("%8X",fet_instr); n();

  printf("\n( opcode = 0x"); g(); printf("%2X",(fet_instr & 0xFF000000 ) >> 24); n();
  printf("    = ");          g(); printf("%2i",(fet_instr & 0xFF000000 ) >> 24); n();
  printf(" )");

  printf("\nfet_operand_2  = 0x"); g(); printf("%2X",fet_operand_2  ); n();
  printf("  ( = ");                g(); printf("%2i",fet_operand_2  ); n();
  printf(" )");
  printf("\nfet_operand_1  = 0x"); g(); printf("%2X",fet_operand_1  ); n();
  printf("  ( = ");                g(); printf("%2i",fet_operand_1  ); n();
  printf(" )");
  printf("\nfet_operand_dst= 0x"); g(); printf("%2X",fet_operand_dst); n();
  printf("  ( = ");                g(); printf("%2i",fet_operand_dst); n();
  printf(" )");
  printf("\n");
}

