/*
  f-cpu/c/xbar/xbar_view.c
  shows status of xbar unit
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com

  version:
           19 July 2002 13:30
Tue Jul 23 12:36:03 CEST 2002 JWS: added latest inputs / outputs

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#include <stdio.h>
#include <fcpusim.h>

void xbar_view(void){
  printf(   "xbar unit input:");

  printf("\nxbar_use_r0     = "); print_true_false(xbar_use_r0);
  printf("  xbar_use_r1     = "); print_true_false(xbar_use_r1);
  printf("  xbar_use_r2     = "); print_true_false(xbar_use_r2);

  printf("\nxbar_r0_port_nr    = "); g(); printf("%2X",xbar_r0_port_nr); n();
  printf("  xbar_r1_port_nr    = "); g(); printf("%2X",xbar_r1_port_nr); n();
  printf("  xbar_r2_port_nr    = "); g(); printf("%2X",xbar_r2_port_nr); n();

  printf("\nxbar_sch_bypass_r0 = "); g(); printf("%2X",xbar_sch_bypass_r0); n();
  printf("  xbar_sch_bypass_r1 = "); g(); printf("%2X",xbar_sch_bypass_r1); n();
  printf("  xbar_sch_bypass_r2 = "); g(); printf("%2X",xbar_sch_bypass_r2); n();

  printf("\nxbar_reg_R0      = "); g(); printf("%16llX",xbar_reg_R0); n();
  printf("  xbar_reg_R1      = "); g(); printf("%16llX",xbar_reg_R1); n();

  printf("\nxbar_reg_R2      = "); g(); printf("%16llX",xbar_reg_R2); n();
  printf("  xbar_EU_nr       = "); g(); printf("%2X",xbar_EU_nr); n();

  printf("\nxbar_w0_port_nr    = "); g(); printf("%2X",xbar_w0_port_nr); n();
  printf("  xbar_w1_port_nr    = "); g(); printf("%2X",xbar_w1_port_nr); n();

  printf("\nxbar unit output:");

  printf("\nxbar_reg_W0      = "); g(); printf("%16llX",xbar_reg_W0); n();
  printf("  xbar_reg_W1      = "); g(); printf("%16llX",xbar_reg_W1); n();

// xbar_read_to_port_r0[16];/* connected to the input 0 of the EU's */
// xbar_read_to_port_r1[16];/* connected to the input 1 of the EU's */
// xbar_read_to_port_r2[16];/* connected to the input 2 of the EU's */
// xbar_write_from_port[25];/* connected to the outputs of the EU's */

  printf("\n");
}




